
$prog = <<__EOP__
require 'sdl'

class Sprite
  def initialize x,y,dx,dy, ary
    @x  = x
    @y  = y
    @dx = dx
    @dy = dy
    @ary = ary
  end
  
  def move
    @x += @dx
    if @x >= 640 then
      @dx *= -1
      @x = 639
    end
    if @x < 0 then
      @dx *= -1
      @x = 0
    end
    @y += @dy
    if @y >= 480 then
      @dy *= -1
      @y = 479
    end
    @y += @dy
    if @y < 0 then
      @dy *= -1
      @y = 0
    end
  end
  
  def draw(screen)
    SDL.blitSurface($image,0,0,32,32,screen,@x,@y)
  end
  
end

def tak x, y, z
  unless y < x
    z
  else
    tak( tak(x-1, y, z),
         tak(y-1, z, x),
         tak(z-1, x, y))
  end
end

def fib n
  if n < 3
    1
  else
    fib(n-1) + fib(n-2)
  end
end

def ack(m, n)
    if m == 0 then
        n + 1
    elsif n == 0 then
        ack(m - 1, 1)
    else
        ack(m - 1, ack(m, n - 1))
    end
end


MAX = 12

def main

  SDL.init( SDL::INIT_VIDEO )

  screen = SDL::setVideoMode(640,480,16,SDL::SWSURFACE)
  
  image = SDL::Surface.loadBMP("icon.bmp")
  image.setColorKey( SDL::SRCCOLORKEY || SDL::RLEACCEL ,0)
  $image = image.displayFormat

  sprites = []
  MAX.times{|bi|
    x = 0
    y = 480/MAX * bi
    dx = bi + 1 # bi%8 + bi%11 + 1
    dy = 0 # bi%8 + bi%13 + 1
    sprites << Sprite.new(x, y, dx, dy, sprites)
  }

  flag = true
  while flag
    while event = SDL::Event2.poll
      if SDL::Event2::KeyDown === event
        if event.sym == SDL::Key::ESCAPE
          flag = false
        end
      end
    end
    
    screen.fillRect(0,0,640,480,0)
    SDL::Key.scan
    
    sprites.each{|bi|
      ack(3, 5)
      bi.move
      bi.draw(screen)
    }
    screen.updateRect(0,0,0,0)
  end
end


main
__EOP__

$lpback = $".dup

puts '-----------------------------------------------------------------------------'
$ans = YARVUtil.eval($prog, $0, $line)
puts '-----------------------------------------------------------------------------'
puts "result: #{$ans.inspect}"
puts "ruby  : #{YARVUtil.eval_in_wrap($prog, $0, $line).inspect}"

$".replace $lpback

YARVUtil.dump_usage_analisys



